using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;
using System.Security.Principal;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region MemberVariables

		private LookUpForm m_LookUp = null;

		private Util util;

		private ClientSession m_session;

		private bool m_isHostLogin;
		private string m_serverNamePort;
		private string m_databaseName;
		private string m_databaseJNDIName;
		private string m_language;
		private string m_extUserId;
		private string m_userName;
		private bool m_bLoggedIn = false;

		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.ContextMenu cntxtMnuListView;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem mnuEditListItem;
		private System.Windows.Forms.MenuItem mnuViewListItem;
		private System.Windows.Forms.MenuItem mnuSearchListItem;
		private System.Windows.Forms.MenuItem mnuDeleteListItem;
		private System.Windows.Forms.ContextMenu cntxtMnuTreeView;
		private System.Windows.Forms.MenuItem mnuEditTreeItem;
		private System.Windows.Forms.MenuItem mnuViewTreeItem;
		private System.Windows.Forms.MenuItem mnuDeleteTreeItem;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem mnuSearchTreeItem;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem mnuAutoGen;
		private System.Windows.Forms.TabControl tabControl2;
		private System.Windows.Forms.TabPage tabFilePlanExplorer;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.TabPage tabTextPage;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TreeView tvFilePlan;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.ColumnHeader columnHeaderName;
		private System.Windows.Forms.ColumnHeader columnHeaderComponent;
		private System.Windows.Forms.ColumnHeader columnHeaderTitle;
		private System.Windows.Forms.ListView lvComponents;
		private System.Windows.Forms.MenuItem mnuTestCode;
		private System.Windows.Forms.MenuItem menuLifeCycleQuery;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.MenuItem mnuAddTreeItemTarget;
		private System.Windows.Forms.MenuItem mnuAddListItemTarget;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem mnuRefreshTreeItem;

		private System.Windows.Forms.TabPage tabLifeCycleReports;
		private System.Windows.Forms.ListView lvLifeCycleReports;
		private System.Windows.Forms.ContextMenu cntxtMnuBatchList;
		private System.Windows.Forms.MenuItem mnuViewLifeCycleResults;
		private System.Windows.Forms.MenuItem mnuDeleteLifeCycleResults;
		private System.Windows.Forms.MenuItem mnuTransitionLifeCycleResults;
		private System.Windows.Forms.MenuItem menuViewTransitionResults;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem mnuMigrateLitsItems;
		private System.Windows.Forms.MenuItem mnuUnMigrateListItems;
		private System.Windows.Forms.MenuItem mnuLogin;
		private System.Windows.Forms.MenuItem mnuHostLogin; //TODO improve this global

		private TreeNode m_lastSelectedNode = null;

		#endregion

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			util = new Util(this,this);

			System.Configuration.AppSettingsReader configurationAppSettings = 
			new System.Configuration.AppSettingsReader();
			//string temp 
			this.m_isHostLogin = ((bool)(configurationAppSettings.GetValue("Form1.m_isHostLogin",typeof(bool))));
			this.m_serverNamePort = ((string)(configurationAppSettings.GetValue("Form1.m_serverNamePort",typeof(string))));
			this.m_databaseName = ((string)(configurationAppSettings.GetValue("Form1.m_databaseName",typeof(string))));
			this.m_language = ((string)(configurationAppSettings.GetValue("Form1.m_language",typeof(string))));
			this.m_userName = ((string)(configurationAppSettings.GetValue("Form1.m_userName",typeof(string))));
			WindowsIdentity me = WindowsIdentity.GetCurrent();
			m_extUserId = me.Name;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.mnuTestCode = new System.Windows.Forms.MenuItem();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.cntxtMnuTreeView = new System.Windows.Forms.ContextMenu();
			this.mnuAddTreeItemTarget = new System.Windows.Forms.MenuItem();
			this.mnuEditTreeItem = new System.Windows.Forms.MenuItem();
			this.mnuViewTreeItem = new System.Windows.Forms.MenuItem();
			this.mnuDeleteTreeItem = new System.Windows.Forms.MenuItem();
			this.mnuRefreshTreeItem = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.mnuSearchTreeItem = new System.Windows.Forms.MenuItem();
			this.menuLifeCycleQuery = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.mnuAutoGen = new System.Windows.Forms.MenuItem();
			this.cntxtMnuListView = new System.Windows.Forms.ContextMenu();
			this.mnuAddListItemTarget = new System.Windows.Forms.MenuItem();
			this.mnuEditListItem = new System.Windows.Forms.MenuItem();
			this.mnuViewListItem = new System.Windows.Forms.MenuItem();
			this.mnuDeleteListItem = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.mnuSearchListItem = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.mnuMigrateLitsItems = new System.Windows.Forms.MenuItem();
			this.mnuUnMigrateListItems = new System.Windows.Forms.MenuItem();
			this.tabControl2 = new System.Windows.Forms.TabControl();
			this.tabFilePlanExplorer = new System.Windows.Forms.TabPage();
			this.lvComponents = new System.Windows.Forms.ListView();
			this.columnHeaderComponent = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderName = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderTitle = new System.Windows.Forms.ColumnHeader();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.tvFilePlan = new System.Windows.Forms.TreeView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.tabLifeCycleReports = new System.Windows.Forms.TabPage();
			this.lvLifeCycleReports = new System.Windows.Forms.ListView();
			this.cntxtMnuBatchList = new System.Windows.Forms.ContextMenu();
			this.mnuViewLifeCycleResults = new System.Windows.Forms.MenuItem();
			this.mnuTransitionLifeCycleResults = new System.Windows.Forms.MenuItem();
			this.menuViewTransitionResults = new System.Windows.Forms.MenuItem();
			this.mnuDeleteLifeCycleResults = new System.Windows.Forms.MenuItem();
			this.tabTextPage = new System.Windows.Forms.TabPage();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.mnuLogin = new System.Windows.Forms.MenuItem();
			this.mnuHostLogin = new System.Windows.Forms.MenuItem();
			this.tabControl2.SuspendLayout();
			this.tabFilePlanExplorer.SuspendLayout();
			this.tabLifeCycleReports.SuspendLayout();
			this.tabTextPage.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuLogin,
																					  this.mnuHostLogin});
			this.menuItem1.Text = "File";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuTestCode});
			this.menuItem3.Text = "Tools";
			// 
			// mnuTestCode
			// 
			this.mnuTestCode.Index = 0;
			this.mnuTestCode.Text = "TestCode";
			this.mnuTestCode.Click += new System.EventHandler(this.mnuTestCode_Click);
			// 
			// cntxtMnuTreeView
			// 
			this.cntxtMnuTreeView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.mnuAddTreeItemTarget,
																							 this.mnuEditTreeItem,
																							 this.mnuViewTreeItem,
																							 this.mnuDeleteTreeItem,
																							 this.mnuRefreshTreeItem,
																							 this.menuItem8,
																							 this.mnuSearchTreeItem,
																							 this.menuLifeCycleQuery,
																							 this.menuItem6,
																							 this.mnuAutoGen});
			this.cntxtMnuTreeView.Popup += new System.EventHandler(this.cntxtMnuTreeView_Popup);
			// 
			// mnuAddTreeItemTarget
			// 
			this.mnuAddTreeItemTarget.Index = 0;
			this.mnuAddTreeItemTarget.Text = "Add";
			this.mnuAddTreeItemTarget.Click += new System.EventHandler(this.mnuAddTreeItemTarget_Click);
			// 
			// mnuEditTreeItem
			// 
			this.mnuEditTreeItem.Index = 1;
			this.mnuEditTreeItem.Text = "Edit";
			this.mnuEditTreeItem.Click += new System.EventHandler(this.mnuEditTreeItem_Click);
			// 
			// mnuViewTreeItem
			// 
			this.mnuViewTreeItem.Index = 2;
			this.mnuViewTreeItem.Text = "View";
			this.mnuViewTreeItem.Click += new System.EventHandler(this.mnuViewTreeItem_Click);
			// 
			// mnuDeleteTreeItem
			// 
			this.mnuDeleteTreeItem.Index = 3;
			this.mnuDeleteTreeItem.Text = "Delete";
			this.mnuDeleteTreeItem.Click += new System.EventHandler(this.mnuDeleteTreeItem_Click);
			// 
			// mnuRefreshTreeItem
			// 
			this.mnuRefreshTreeItem.Index = 4;
			this.mnuRefreshTreeItem.Text = "Refresh";
			this.mnuRefreshTreeItem.Click += new System.EventHandler(this.mnuRefreshTreeItem_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 5;
			this.menuItem8.Text = "-";
			// 
			// mnuSearchTreeItem
			// 
			this.mnuSearchTreeItem.Index = 6;
			this.mnuSearchTreeItem.Text = "Search...";
			this.mnuSearchTreeItem.Click += new System.EventHandler(this.mnuSearchTreeItem_Click);
			// 
			// menuLifeCycleQuery
			// 
			this.menuLifeCycleQuery.Index = 7;
			this.menuLifeCycleQuery.Text = "Life Cycle Query...";
			this.menuLifeCycleQuery.Click += new System.EventHandler(this.menuLifeCycleQuery_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 8;
			this.menuItem6.Text = "-";
			// 
			// mnuAutoGen
			// 
			this.mnuAutoGen.Index = 9;
			this.mnuAutoGen.Text = "AutoGen";
			this.mnuAutoGen.Click += new System.EventHandler(this.mnuAutoGen_Click);
			// 
			// cntxtMnuListView
			// 
			this.cntxtMnuListView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.mnuAddListItemTarget,
																							 this.mnuEditListItem,
																							 this.mnuViewListItem,
																							 this.mnuDeleteListItem,
																							 this.menuItem9,
																							 this.mnuSearchListItem,
																							 this.menuItem4,
																							 this.mnuMigrateLitsItems,
																							 this.mnuUnMigrateListItems});
			this.cntxtMnuListView.Popup += new System.EventHandler(this.cntxtMnuListView_Popup);
			// 
			// mnuAddListItemTarget
			// 
			this.mnuAddListItemTarget.Index = 0;
			this.mnuAddListItemTarget.Text = "Add";
			// 
			// mnuEditListItem
			// 
			this.mnuEditListItem.Index = 1;
			this.mnuEditListItem.Text = "Edit";
			this.mnuEditListItem.Click += new System.EventHandler(this.mnuEditListItem_Click);
			// 
			// mnuViewListItem
			// 
			this.mnuViewListItem.Index = 2;
			this.mnuViewListItem.Text = "View";
			this.mnuViewListItem.Click += new System.EventHandler(this.mnuViewListItem_Click);
			// 
			// mnuDeleteListItem
			// 
			this.mnuDeleteListItem.Index = 3;
			this.mnuDeleteListItem.Text = "Delete";
			this.mnuDeleteListItem.Click += new System.EventHandler(this.mnuDeleteListItem_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 4;
			this.menuItem9.Text = "-";
			// 
			// mnuSearchListItem
			// 
			this.mnuSearchListItem.Index = 5;
			this.mnuSearchListItem.Text = "Search...";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 6;
			this.menuItem4.Text = "-";
			// 
			// mnuMigrateLitsItems
			// 
			this.mnuMigrateLitsItems.Index = 7;
			this.mnuMigrateLitsItems.Text = "Put in Container";
			this.mnuMigrateLitsItems.Click += new System.EventHandler(this.mnuMigrateLitsItems_Click);
			// 
			// mnuUnMigrateListItems
			// 
			this.mnuUnMigrateListItems.Index = 8;
			this.mnuUnMigrateListItems.Text = "Remove From Container";
			this.mnuUnMigrateListItems.Click += new System.EventHandler(this.mnuUnMigrateListItems_Click);
			// 
			// tabControl2
			// 
			this.tabControl2.Controls.Add(this.tabFilePlanExplorer);
			this.tabControl2.Controls.Add(this.tabLifeCycleReports);
			this.tabControl2.Controls.Add(this.tabTextPage);
			this.tabControl2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl2.Location = new System.Drawing.Point(0, 0);
			this.tabControl2.Name = "tabControl2";
			this.tabControl2.SelectedIndex = 0;
			this.tabControl2.Size = new System.Drawing.Size(792, 585);
			this.tabControl2.TabIndex = 8;
			this.tabControl2.SelectedIndexChanged += new System.EventHandler(this.tabControl2_SelectedIndexChanged);
			// 
			// tabFilePlanExplorer
			// 
			this.tabFilePlanExplorer.Controls.Add(this.lvComponents);
			this.tabFilePlanExplorer.Controls.Add(this.splitter2);
			this.tabFilePlanExplorer.Controls.Add(this.tvFilePlan);
			this.tabFilePlanExplorer.Controls.Add(this.splitter1);
			this.tabFilePlanExplorer.Location = new System.Drawing.Point(4, 22);
			this.tabFilePlanExplorer.Name = "tabFilePlanExplorer";
			this.tabFilePlanExplorer.Size = new System.Drawing.Size(784, 559);
			this.tabFilePlanExplorer.TabIndex = 0;
			this.tabFilePlanExplorer.Text = "File Plan Explorer";
			// 
			// lvComponents
			// 
			this.lvComponents.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.columnHeaderComponent,
																						   this.columnHeaderName,
																						   this.columnHeaderTitle});
			this.lvComponents.ContextMenu = this.cntxtMnuListView;
			this.lvComponents.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvComponents.FullRowSelect = true;
			this.lvComponents.Location = new System.Drawing.Point(198, 0);
			this.lvComponents.Name = "lvComponents";
			this.lvComponents.Size = new System.Drawing.Size(586, 559);
			this.lvComponents.SmallImageList = this.imageList1;
			this.lvComponents.TabIndex = 3;
			this.lvComponents.View = System.Windows.Forms.View.Details;
			// 
			// columnHeaderComponent
			// 
			this.columnHeaderComponent.Text = "Component";
			this.columnHeaderComponent.Width = 100;
			// 
			// columnHeaderName
			// 
			this.columnHeaderName.Text = "Name";
			this.columnHeaderName.Width = 100;
			// 
			// columnHeaderTitle
			// 
			this.columnHeaderTitle.Text = "Title";
			this.columnHeaderTitle.Width = 500;
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(195, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 559);
			this.splitter2.TabIndex = 2;
			this.splitter2.TabStop = false;
			// 
			// tvFilePlan
			// 
			this.tvFilePlan.ContextMenu = this.cntxtMnuTreeView;
			this.tvFilePlan.Dock = System.Windows.Forms.DockStyle.Left;
			this.tvFilePlan.ImageList = this.imageList1;
			this.tvFilePlan.Location = new System.Drawing.Point(3, 0);
			this.tvFilePlan.Name = "tvFilePlan";
			this.tvFilePlan.Size = new System.Drawing.Size(192, 559);
			this.tvFilePlan.TabIndex = 1;
			this.tvFilePlan.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvFilePlan_AfterSelect);
			this.tvFilePlan.BeforeExpand += new System.Windows.Forms.TreeViewCancelEventHandler(this.tvFilePlan_BeforeExpand);
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(0, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 559);
			this.splitter1.TabIndex = 0;
			this.splitter1.TabStop = false;
			// 
			// tabLifeCycleReports
			// 
			this.tabLifeCycleReports.Controls.Add(this.lvLifeCycleReports);
			this.tabLifeCycleReports.Location = new System.Drawing.Point(4, 22);
			this.tabLifeCycleReports.Name = "tabLifeCycleReports";
			this.tabLifeCycleReports.Size = new System.Drawing.Size(784, 559);
			this.tabLifeCycleReports.TabIndex = 2;
			this.tabLifeCycleReports.Text = "Life Cycle Reports";
			// 
			// lvLifeCycleReports
			// 
			this.lvLifeCycleReports.ContextMenu = this.cntxtMnuBatchList;
			this.lvLifeCycleReports.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvLifeCycleReports.FullRowSelect = true;
			this.lvLifeCycleReports.Location = new System.Drawing.Point(0, 0);
			this.lvLifeCycleReports.Name = "lvLifeCycleReports";
			this.lvLifeCycleReports.Size = new System.Drawing.Size(784, 559);
			this.lvLifeCycleReports.TabIndex = 0;
			this.lvLifeCycleReports.View = System.Windows.Forms.View.Details;
			// 
			// cntxtMnuBatchList
			// 
			this.cntxtMnuBatchList.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							  this.mnuViewLifeCycleResults,
																							  this.mnuTransitionLifeCycleResults,
																							  this.menuViewTransitionResults,
																							  this.mnuDeleteLifeCycleResults});
			// 
			// mnuViewLifeCycleResults
			// 
			this.mnuViewLifeCycleResults.Index = 0;
			this.mnuViewLifeCycleResults.Text = "View Results";
			this.mnuViewLifeCycleResults.Click += new System.EventHandler(this.mnuViewLifeCycleResults_Click);
			// 
			// mnuTransitionLifeCycleResults
			// 
			this.mnuTransitionLifeCycleResults.Index = 1;
			this.mnuTransitionLifeCycleResults.Text = "Transition";
			this.mnuTransitionLifeCycleResults.Click += new System.EventHandler(this.mnuTransitionLifeCycleResults_Click);
			// 
			// menuViewTransitionResults
			// 
			this.menuViewTransitionResults.Index = 2;
			this.menuViewTransitionResults.Text = "Show Transition Results...";
			this.menuViewTransitionResults.Click += new System.EventHandler(this.menuViewTransitionResults_Click);
			// 
			// mnuDeleteLifeCycleResults
			// 
			this.mnuDeleteLifeCycleResults.Index = 3;
			this.mnuDeleteLifeCycleResults.Text = "Delete";
			this.mnuDeleteLifeCycleResults.Click += new System.EventHandler(this.mnuDeleteLifeCycleResults_Click);
			// 
			// tabTextPage
			// 
			this.tabTextPage.Controls.Add(this.textBox1);
			this.tabTextPage.Location = new System.Drawing.Point(4, 22);
			this.tabTextPage.Name = "tabTextPage";
			this.tabTextPage.Size = new System.Drawing.Size(784, 559);
			this.tabTextPage.TabIndex = 1;
			this.tabTextPage.Text = "Log Messages";
			// 
			// textBox1
			// 
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBox1.Location = new System.Drawing.Point(0, 0);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(784, 559);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 563);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(792, 22);
			this.statusBar1.TabIndex = 9;
			this.statusBar1.Text = "statusBar1";
			// 
			// mnuLogin
			// 
			this.mnuLogin.Index = 0;
			this.mnuLogin.Text = "Login";
			this.mnuLogin.Click += new System.EventHandler(this.mnuLogin_Click);
			// 
			// mnuHostLogin
			// 
			this.mnuHostLogin.Index = 1;
			this.mnuHostLogin.Text = "Host Login";
			this.mnuHostLogin.Click += new System.EventHandler(this.mnuHostLogin_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 585);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.tabControl2);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = ((string)(configurationAppSettings.GetValue("Form1.Text", typeof(string))));
			this.Load += new System.EventHandler(this.Form1_Load);
			this.tabControl2.ResumeLayout(false);
			this.tabFilePlanExplorer.ResumeLayout(false);
			this.tabLifeCycleReports.ResumeLayout(false);
			this.tabTextPage.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		#region Utility

		public ClientSession irmFactory
		{
			get
			{
				return this.m_session;
			}
		}

		public void SetFilePlanTabActive()
		{
			tabControl2.SelectedTab = tabFilePlanExplorer;
		}

		//Given enough info you can automatically find anything
		public void FindTreeNode(long nFlPnCmpntId, int viewId, long fplnCmpntDefId)
		{
			if(viewId == 0)
			{
				if(fplnCmpntDefId != 0)
				{
					string xml = m_session.getDefinitionController().getComponentDefinitionById(fplnCmpntDefId);
					IRMList list = new IRMList(xml,"PrmViewID","FlPlnViewNm");
					viewId = Convert.ToInt32(list.PrimaryKey(0));
				}
			}
			if(viewId == 0)
			{
				return; //Nothing we can do without viewId
			}
			string fullPath = m_session.getNavigationController().getFullPathById(nFlPnCmpntId, viewId, (int)IRMConstants.DualNamingOptions.BY_NAME);
			string sysFullPathPrefix = m_session.getConfigurationController().getEngineConfigValue("sysFullPathPrefix",0);
			string sysFullPathLevelDelimeter = m_session.getConfigurationController().getEngineConfigValue("sysFullPathLevelDelimiter",0);

			//Split the full pathh up into an array of names
			string temp = fullPath.Replace(sysFullPathPrefix,"");
			char [] delimiter = sysFullPathLevelDelimeter.ToCharArray();
			string[] str = temp.Split(delimiter);

			TreeNode node = null;

			//Get view Node first
			string name = str[0];
			TreeNodeCollection views = tvFilePlan.Nodes[0].Nodes;
			for(int i = 0; i < views.Count; i++)
			{
				if(name == views[i].Text)
				{
					node = views[i];
				}
			}
			//Then expand all nodes along the path
			for(int i = 1; i  < str.Length; i++)
			{
				IRMComponent irm = (IRMComponent)node.Tag;
				name = str[i];
				bool newTargets = false;
				int count = node.Nodes.Count;
				//Check if targets exist
				if(count == 1)
				{
					//If the target list is not there add it
					if(node.FirstNode.Tag == null)
					{
						CommonTasks.addTargetList(m_session, node,irm.FlPlnViewID,irm.FlPlnCmpntID);
						newTargets = true;
					}
				}
				if(!newTargets)//Don't have to refresh if you just added the list
				{
					//Refresh the node list incase new components were added by another client
					CommonTasks.Refresh(m_session,node,irm.FlPlnViewID,irm.FlPlnCmpntID,false,false);
				}
				node.Expand();
				count = node.Nodes.Count;
				for(int j = 0; j < count; j++)
				{
					if(node.Nodes[j].Text == name)
					{
						node = node.Nodes[j];
						irm = (IRMComponent)node.Tag; 
						//If this is the last node then we can display the targets for it
						if(i == str.Length - 1)
						{
							node.EnsureVisible();
							tvFilePlan.SelectedNode = node;
							CommonTasks.DisplayTargetList(m_session,lvComponents,irm.FlPlnViewID,irm.FlPlnCmpntID);
						}
						break;
					}
				}
			}
		}

		public void log(string location, string msg)
		{
			textBox1.AppendText("\r\n" + location + "\r\n\t" + msg);
		}

		public void appendText(string msg)
		{
			textBox1.AppendText(msg);
		}

		private bool initClientSession(bool isHostLogin)
		{
			bool bFound = false;
			this.m_databaseJNDIName = null;
			
			if(!m_bLoggedIn)
			{
				m_session = new ClientSession(this.m_serverNamePort);
			}
				
			//Get the XML containing the list of available data sources
			string dataSourceList = m_session.getDataSourceList();

			//Get the JNDIName name for database
			IRMList list = new IRMList(dataSourceList,"JNDIName","Name");
			//XmlDocument doc = new XmlDocument();
			//doc.LoadXml(dataSourceList);
			//XmlNodeList nodes = doc.GetElementsByTagName("Item");
			if(list.Count > 0)
			{
				for(int i=0; i < list.Count; i++)
				{
					string name = list.Caption(i);
					if(name.Equals(this.m_databaseName))
					{
						this.m_databaseJNDIName = list.PrimaryKey(i);
						bFound = true;
						break;
					}
				}
				if(!bFound)
				{
					string temp = this.m_databaseName;
					this.m_databaseName = list.Caption(0);
					this.m_databaseJNDIName = list.PrimaryKey(0);

					MessageBox.Show("The Database: " + temp + " was not found in the list of available databases. " +
						"Using the first available database: " + this.m_databaseName);
				}
				if(isHostLogin)
				{
					m_session.hostLogin(this.m_extUserId,"QAHost","SampleHostUserName","cronos",this.m_databaseJNDIName,"",this.m_language);
					statusBar1.Text = "External user: " + this.m_extUserId + "\r\nServer : " + this.m_serverNamePort + "\r\ndatabase JNDIName: " + this.m_databaseJNDIName;
					m_bLoggedIn = true;
					return true;
				}
				else
				{
					LoginForm frm = new LoginForm(m_session, this, list, this.m_userName, this.m_databaseName, this.m_language);
					if(frm.ShowDialog(this) == DialogResult.OK)
					{
						m_bLoggedIn = true;
						statusBar1.Text = "Internal User: " + frm.SelectedUserName + "\r\nServer : " + this.m_serverNamePort + "\r\ndatabase JNDIName: " + frm.SelectedDatabaseName;
						return true;
					}
					else
					{
						return false;
					}
				}
			}
			else
			{
				util.log("No database information");
				return false;
			}
		}

		#endregion

		#region treeViewUtilityMethods

		private bool DeleteFilePlanComponent(long nFlPlnCmpntID, string strFlPlnCmpntNm)
		{
			string msg = "Delete Component: " + strFlPlnCmpntNm;
			if(MessageBox.Show(this,msg,"Component Operations",MessageBoxButtons.YesNo) == DialogResult.Yes)
			{
				try
				{
					m_session.getFilePlanComponentController().deleteFilePlanComponent(nFlPlnCmpntID,1);
					return true;
				}
				catch(System.Net.WebException we)
				{
					util.logWebException(we);
				}
				catch(System.Web.Services.Protocols.SoapException s)
				{
					util.handleSoapException(s,false); //false indicates we will not check for time ou here
					util.showSoapException(s);
				}
			}
			return false;
		}

		private bool DeleteFilePlanView(int nFlPlnViewID,string strFlPlnViewNm)
		{
			string msg = "Delete View: " + strFlPlnViewNm;
			if(MessageBox.Show(this,msg,"Component Operations",MessageBoxButtons.YesNo) == DialogResult.Yes)
			{
				try
				{
					m_session.getFilePlanDesignController().deleteFilePlanView(nFlPlnViewID);
					return true;
				}
				catch(System.Net.WebException we)
				{
					util.logWebException(we);
				}
				catch(System.Web.Services.Protocols.SoapException s)
				{
					util.handleSoapException(s,false); //false indicates we will not check for time ou here
					util.showSoapException(s);
				}
			}
			return false;
		}

		private string getFullPath(long nFlPlnCmpntID, int nFlPlnViewID)
		{
			return m_session.getNavigationController().getFullPathById(nFlPlnCmpntID,nFlPlnViewID,1);
		}

		private void ExecuteQuery(byte queryType)
		{

		}

		private void autoGen(IRMComponent irm)
		{
			addFilePlanComponents(irm.FlPlnCmpntID, irm.FlPlnViewID, 10);
		}

		#endregion

		#region treeViewEvents
		private void tvFilePlan_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag;
			m_lastSelectedNode = tvFilePlan.SelectedNode;

			if(irm.FlPlnCmpntDefID > (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_COMPONENT || irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
			{
				CommonTasks.DisplayTargetList(m_session, lvComponents, irm.FlPlnViewID,irm.FlPlnCmpntID);
			}
			else if(irm.FlPlnCmpntDefID == IRMComponent.ROOT)
			{
				DisplayViewList(false);
			}
			else
			{
				lvComponents.Items.Clear();
			}
		}

		private void mnuDeleteTreeItem_Click(object sender, System.EventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag;
			if(irm.FlPlnCmpntDefID > (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_COMPONENT)
			{
				if(DeleteFilePlanComponent(irm.FlPlnCmpntID, irm.FlPlnCmpntNm))
				{
					tvFilePlan.SelectedNode.Remove();
				}
			}
			else if(irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
			{
				if(DeleteFilePlanView(irm.FlPlnViewID,irm.FlPlnViewNm))
				{
					tvFilePlan.SelectedNode.Remove();
				}
			}
			lvComponents.Items.Clear();
			lvComponents.Columns.Clear();
		}

		private void menuLifeCycleQuery_Click(object sender, System.EventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag; 
			m_lastSelectedNode = tvFilePlan.SelectedNode;

			string xmlQuery; // = m_session.getQueryController().getQueryById(101);

			SavedSearchesForm srchForm = new SavedSearchesForm(m_session, (byte)IRMConstants.QueryTypes.LIFE_CYCLE);
			if(srchForm.ShowDialog(this) == DialogResult.OK)
			{
				xmlQuery = srchForm.XMLQuery;	
			}
			else
			{
				return;
			}
			string strScope = "";
			if(irm.FlPlnViewID != 0)
			{
				strScope = m_session.getNavigationController().getFullPathById(irm.FlPlnCmpntID,(long)irm.FlPlnViewID,(int)IRMConstants.DualNamingOptions.BY_NAME);
			}
			
			IRMBatchQuery irmQuery = new IRMBatchQuery(xmlQuery, m_session, strScope, true, OptionalFields.REFERENCE_DATE_TO);
			irmQuery.Initialize();

			//TODO no such thing as IRMConstants.QueryResultOptions.NORMAL for Batch Ops???
			QueryForm frm = new QueryForm(this, irmQuery,"Fill in all the parameter values to complete the following Life Cycle Query.",(int)IRMConstants.QueryResultOptions.INCLUDE_COLUMNS);
			if(frm.ShowDialog(this) == DialogResult.OK)
			{
				IRMTaskResultsForm frmTaskResultsForm = new IRMTaskResultsForm(frm.getIRMBatchQuery());
				if(frmTaskResultsForm.ShowDialog(this) == DialogResult.OK)
				{
					IRMLifeCycleResultList rl = frmTaskResultsForm.LifeCycleResultList;

					//TODO improve this global
					string strTaskId = frmTaskResultsForm.TaskID;

					//Make sure that only the following columns will be displayed
					rl.AddColumn("NameFullPath");
					rl.AddColumn("Conflict");
					rl.AddColumn("NextEligiblePhaseName");
					rl.AddColumn("NextEligiblePhaseDate");

					LifeCycleResultListForm lcrlFrm = new LifeCycleResultListForm(strTaskId, m_session,this,rl,irm.FlPlnViewID,true);
					lcrlFrm.Show();
				}
			}
		}

		private void mnuSearchTreeItem_Click(object sender, System.EventArgs e)
		{
			
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag; 
			m_lastSelectedNode = tvFilePlan.SelectedNode;

			string xmlQuery; // = m_session.getQueryController().getQueryById(101);

			SavedSearchesForm srchForm = new SavedSearchesForm(m_session, (byte)IRMConstants.QueryTypes.ADVANCED);
			if(srchForm.ShowDialog(this) == DialogResult.OK)
			{
				xmlQuery = srchForm.XMLQuery;	
			}
			else
			{
				return;
			}
			string strScope = "";
			if(irm.FlPlnViewID != 0)
			{
				strScope = m_session.getNavigationController().getFullPathById(irm.FlPlnCmpntID,(long)irm.FlPlnViewID,(int)IRMConstants.DualNamingOptions.BY_NAME);
			}
			
			//Query constructor
			//Note the addDisplayInfo flag must be set to true if we are going to use
			//Display information to create a Query Form
			IRMQuery irmQuery = new IRMQuery(xmlQuery, m_session, strScope, true);
			irmQuery.Initialize(); //Note this method must always be called first.
			QueryForm frm = new QueryForm(this, irmQuery, "Fill in all the parameter values to complete the following Query.",(int)IRMConstants.QueryResultOptions.INCLUDE_COLUMNS);
			if(frm.ShowDialog(this) == DialogResult.OK)
			{
				IRMResultList rl = new IRMResultList(irmQuery);
				//DisplayResultList(rl, irm.FlPlnViewID);
				ResultListForm rlFrm = new ResultListForm(m_session, this, rl, irm.FlPlnViewID);
				rlFrm.Show();
			}
		}

		private void mnuAddTreeItemTarget_Click(object sender, System.EventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag;
			m_lastSelectedNode = tvFilePlan.SelectedNode;

			if(irm.FlPlnCmpntDefID == IRMComponent.ROOT)
			{
				MessageBox.Show("Add View - Code under construction");
			}
			if(irm.FlPlnCmpntDefID > 0 || irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
			{
				//AddTarget(irm);
				string xmlList = m_session.getFilePlanComponentController().getAllowedTargetList(irm.FlPlnCmpntID,irm.FlPlnViewID);
				IRMList list = new IRMList(xmlList,"FlPlnCmpntDefTgtID","FlPlnCmpntDefNm");
				
				for(int i = list.Count - 1; i > -1; i--)
				{
					int nPrmViewID = Convert.ToInt32(list.getAttributeValue(i,"PrmViewID"));
					if(nPrmViewID != irm.FlPlnViewID)
					{
						list.removeItem(i);
					}
				}

				if(list.Count > 0)
				{
					long nFlPlnCmpntDefTgtID = 0;
					if(list.Count > 1)
					{
						AllowedTargetsForm frm = new AllowedTargetsForm(list);
						if(frm.ShowDialog(this) == DialogResult.OK)
						{
							nFlPlnCmpntDefTgtID = frm.FlPlnCmpntDefTgtID;
						}
					}
					else
					{
						nFlPlnCmpntDefTgtID = Convert.ToInt32(list.PrimaryKey(0));
					}
					//MessageBox.Show("FlPlnCmpntDefTgtID = " + nFlPlnCmpntDefTgtID);

					string xml = m_session.getTemplateController().getNewComponent(nFlPlnCmpntDefTgtID,0,0,(int)IRMConstants.TemplateOptions.EXPAND_LISTS_AND_PROFILE_FIELDS);
					IRMFields fields = new IRMFields(xml);
					fields.hideSecurityFields(); //This is a convenience method to hide security fields if they are not being used
					fields.inactivateSecurityFields(); //This is a convenience method to make sure security fields are not added
					
					//Hide some fields we never want to display
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
					
					//Inactivate fields we do not want to be set in the Fields Collection
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
					

					ComponentForm cmpntFrm = new ComponentForm(m_session,irm,this,fields,ComponentForm.ADD);
					if(cmpntFrm.ShowDialog(this) == DialogResult.OK)
					{
						CommonTasks.DisplayTargetList(m_session, lvComponents, irm.FlPlnViewID,irm.FlPlnCmpntID);
						CommonTasks.Refresh(m_session, tvFilePlan.SelectedNode,irm.FlPlnViewID,irm.FlPlnCmpntID,false,false);
					}
				}
				else
				{
					MessageBox.Show("There are no Add Relationships defined for this Source");
				}
			}
		}

		private void mnuEditTreeItem_Click(object sender, System.EventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag;
			m_lastSelectedNode = tvFilePlan.SelectedNode;

			if(irm.FlPlnCmpntDefID == IRMComponent.ROOT)
			{
				MessageBox.Show("Add View - Code under construction");
			}
			if(irm.FlPlnCmpntDefID > 0 || irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
			{
				string xml = m_session.getTemplateController().getFilePlanComponent(irm.FlPlnCmpntID,0,(int)IRMConstants.TemplateOptions.EXPAND_LISTS_AND_PROFILE_FIELDS);

				IRMFields fields = new IRMFields(xml);
				fields.hideSecurityFields(); //This is a convenience method to hide security fields if they are not being used
				fields.inactivateSecurityFields(); //This is a convenience method to make sure security fields are not added
					
				//Hide some fields we never want to display
				fields.setVisabilityByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
				fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
				fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
					
				//Inactivate fields we do not want to be set in the Fields Collection
				fields.setActiveStateByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
				fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
				fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
					
				ComponentForm cmpntFrm = new ComponentForm(m_session, irm, this, fields, ComponentForm.EDIT);
				if(cmpntFrm.ShowDialog(this) == DialogResult.OK)
				{
					//Get the parent node
					TreeNode parent = m_lastSelectedNode.Parent;
					
					//Remove the updated node
					m_lastSelectedNode.Remove();

					//Refresh the local branch of the tree view
					irm = (IRMComponent)parent.Tag;
					CommonTasks.Refresh(m_session,parent,irm.FlPlnViewID,irm.FlPlnCmpntID,false,false);
				}
			}
		}

		private void mnuAutoGen_Click(object sender, System.EventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag; 
			if(irm.FlPlnCmpntDefID > (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_COMPONENT || irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
			{
				this.Cursor = Cursors.WaitCursor;
				autoGen(irm);
				CommonTasks.DisplayTargetList(m_session, lvComponents, irm.FlPlnViewID,irm.FlPlnCmpntID);
				CommonTasks.Refresh(m_session, tvFilePlan.SelectedNode,irm.FlPlnViewID,irm.FlPlnCmpntID,false,false);
				this.Cursor = Cursors.Default;
			}
		}

		private void cntxtMnuTreeView_Popup(object sender, System.EventArgs e)
		{
			mnuAddTreeItemTarget.Enabled = true;
			mnuEditTreeItem.Enabled = true;
			mnuViewTreeItem.Enabled = true;
			mnuDeleteTreeItem.Enabled = true;
			mnuRefreshTreeItem.Enabled = true;
			mnuSearchTreeItem.Enabled = true;
			menuLifeCycleQuery.Enabled = true;
			mnuAutoGen.Enabled = true;

			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag; 
			if(irm.FlPlnCmpntDefID > (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_COMPONENT)
			{

			}
			if(irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
			{

			}
			else if(irm.FlPlnCmpntDefID == IRMComponent.ROOT)
			{
				mnuEditTreeItem.Enabled = false;
				mnuViewTreeItem.Enabled = false;
				mnuDeleteTreeItem.Enabled = false;
				mnuAutoGen.Enabled = false;
			}
		}

		private void tvFilePlan_BeforeExpand(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			int count = e.Node.Nodes.Count;
			if(count == 1)
			{
				if(e.Node.FirstNode.Tag == null)
				{
					IRMComponent irm = (IRMComponent)e.Node.Tag;
					CommonTasks.addTargetList(m_session, e.Node,irm.FlPlnViewID,irm.FlPlnCmpntID);
				}
			}
		}

		private void mnuRefreshTreeItem_Click(object sender, System.EventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag;
			if(irm.FlPlnViewID == 0)
			{
				this.Cursor = Cursors.WaitCursor;
				CommonTasks.RefreshViews(m_session,tvFilePlan.SelectedNode,true);
				this.Cursor = Cursors.Default;

			}
			else
			{
				this.Cursor = Cursors.Default;
				CommonTasks.Refresh(m_session,tvFilePlan.SelectedNode,irm.FlPlnViewID,irm.FlPlnCmpntID,true,false);
				this.Cursor = Cursors.Default;
			}
		}

		private void mnuViewTreeItem_Click(object sender, System.EventArgs e)
		{
			IRMComponent irm = (IRMComponent)tvFilePlan.SelectedNode.Tag;
			CommonTasks.viewSeletedItem(this,m_session,irm);
		}

		#endregion

		#region ListViewUtilityMethods

		private void DisplayViewList(bool onlyRootNavigation)
		{
			string xml = m_session.getFilePlanDesignController().getFilePlanViewList(onlyRootNavigation);
			XmlDocument doc = new XmlDocument();
			try
			{
				doc.LoadXml(xml);
				XmlNodeList itemNodes = doc.GetElementsByTagName("Item");
				
				lvComponents.Items.Clear();
				lvComponents.Columns.Clear();

				lvComponents.Columns.Add(new ColumnHeader());
				lvComponents.Columns[0].Text = "Component";
				lvComponents.Columns[0].Width = 200;

				lvComponents.Columns.Add(new ColumnHeader());
				lvComponents.Columns[1].Text = "Name";
				lvComponents.Columns[1].Width = 200;
				
				for(int i = 0; i < itemNodes.Count; i++)
				{
					int nFlPlnViewID = System.Convert.ToInt32(itemNodes.Item(i).Attributes.GetNamedItem("FlPlnViewID").Value);
					string strFlPlnViewNm = itemNodes.Item(i).Attributes.GetNamedItem("FlPlnViewNm").Value;
					IRMComponent irm = new IRMComponent(nFlPlnViewID,strFlPlnViewNm);
					ListViewItem lvItem = lvComponents.Items.Add(new ListViewItem(
						new string[]{irm.FlPlnCmpntDefNm,irm.FlPlnViewNm,""},1 ));
					lvItem.Tag = irm;
				}
			}
			catch(XmlException ed)
			{
				util.log("LoadXml Error: " + ed.Message);
			}
		}

		/*
		//This method displays all the targets for selected nFlPlnCmpntID in ListView
		private void DisplayTargetList(int nFlPlnViewID, long nFlPlnCmpntID)
		{
			string xml = m_session.getNavigationController().getTargetList(nFlPlnViewID,nFlPlnCmpntID,0,"",0,0);
			XmlDocument doc = new XmlDocument();
			try
			{
				doc.LoadXml(xml);
				XmlNodeList itemNodes = doc.GetElementsByTagName("Item");
						
				lvComponents.Items.Clear();
				lvComponents.Columns.Clear();

				lvComponents.Columns.Add(new ColumnHeader());
				lvComponents.Columns[0].Text = "Component";
				lvComponents.Columns[0].Width = 200;

				lvComponents.Columns.Add(new ColumnHeader());
				lvComponents.Columns[1].Text = "Name";
				lvComponents.Columns[1].Width = 200;

				lvComponents.Columns.Add(new ColumnHeader());
				lvComponents.Columns[2].Text = "Title";
				lvComponents.Columns[2].Width = 500;

				for(int i = 0; i < itemNodes.Count; i++)
				{
					IRMComponent irm = new IRMComponent(itemNodes[i]);
					
					ListViewItem lvItem = lvComponents.Items.Add(new ListViewItem(
						new string[]{irm.FlPlnCmpntDefNm,irm.FlPlnCmpntNm,irm.FlPlnCmpntTtl}, 3 ));
								
					lvItem.Tag = irm;
			 
				}
			}
			catch(XmlException ed)
			{
				util.log("LoadXml Error: " + ed.Message);
			}
		}
		*/

		private void RefreshContainerView(int containerViewId)
		{
			//Look through existing View Nodes for the containerViewId
			TreeNodeCollection viewNodes = tvFilePlan.Nodes[0].Nodes;
			for(int i = 0; i < viewNodes.Count; i++)
			{
				IRMComponent irm = (IRMComponent)viewNodes[i].Tag;
				if(irm.FlPlnViewID == containerViewId)
				{
					CommonTasks.Refresh(m_session,viewNodes[i],containerViewId,0,true,false);
				}
			}
		}

		#endregion

		#region ListViewEvents

		private void mnuEditListItem_Click(object sender, System.EventArgs e)
		{
			int count = lvComponents.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = lvComponents.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				IRMComponent irm = (IRMComponent)lvi.Tag;
				if(irm.FlPlnCmpntDefID > 0 || irm.FlPlnCmpntDefID == (int)IRMConstants.ComponentDefinitionTypes.FILE_PLAN_VIEW)
				{
					string xml = m_session.getTemplateController().getFilePlanComponent(irm.FlPlnCmpntID,0,(int)IRMConstants.TemplateOptions.EXPAND_LISTS_AND_PROFILE_FIELDS);

					IRMFields fields = new IRMFields(xml);
					fields.hideSecurityFields(); //This is a convenience method to hide security fields if they are not being used
					fields.inactivateSecurityFields(); //This is a convenience method to make sure security fields are not added
						
					//Hide some fields we never want to display
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
					fields.setVisabilityByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
						
					//Inactivate fields we do not want to be set in the Fields Collection
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("FlPlnCmpntID",false);
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastAddtnDt",false);
					fields.setActiveStateByFlPlnCmpntAttrDefColNm("LastRtrvDt",false);
						
					ComponentForm cmpntFrm = new ComponentForm(m_session, irm ,this,fields,ComponentForm.EDIT);
					if(cmpntFrm.ShowDialog(this) == DialogResult.OK)
					{
						//Refresh the List View
						irm = (IRMComponent)m_lastSelectedNode.Tag;
						CommonTasks.DisplayTargetList(m_session, lvComponents, irm.FlPlnViewID,irm.FlPlnCmpntID);
					}
				}
			}
		}

		private void mnuMigrateLitsItems_Click(object sender, System.EventArgs e)
		{
			int count = lvComponents.SelectedItems.Count;
			if(count > 0)
			{
				if(m_LookUp == null)
				{
					m_LookUp = new LookUpForm(m_session,this);
				}
				if(m_LookUp.ShowDialog(this) == DialogResult.OK)
				{
					string msg = "Put the Selected Items in the Container: " + m_LookUp.SelectedComponent.FlPlnCmpntNm;
					if(MessageBox.Show(this,msg,"Component Operations",MessageBoxButtons.YesNo) == DialogResult.No)
					{
						return;
					}
					IEnumerator items = lvComponents.SelectedItems.GetEnumerator();
					IRMComponent irm;
					while(items.MoveNext())
					{
						ListViewItem lvi = (ListViewItem)items.Current;
						irm = (IRMComponent)lvi.Tag;
						string sourcList =
						"<List>" +
							"<Item FlPlnCmpntID=\"" + m_LookUp.SelectedComponent.FlPlnCmpntID +
								"\" FlPlnViewID=\"" + m_LookUp.SelectedComponent.FlPlnViewID + "\" />" +
						"</List>"; 
						try
						{
							m_session.getFilePlanComponentController().addSource(irm.FlPlnCmpntID,sourcList);
							lvi.Selected = false;
						}
						catch(System.Net.WebException we)
						{
							util.logWebException(we);
							return;
						}
						catch(System.Web.Services.Protocols.SoapException s)
						{
							util.handleSoapException(s,false); //false indicates we will not check for time out here
							util.showSoapException(s);
							return;
						}
					}
					
					RefreshContainerView(m_LookUp.SelectedComponent.FlPlnViewID);

					//TODO how do we refresh the container node
					//Note m_LookUp.SelectedNode only refreshes lookup
					//CommonTasks.Refresh(m_session,m_LookUp.SelectedNode,m_LookUp.SelectedComponent.FlPlnViewID,m_LookUp.SelectedComponent.FlPlnCmpntID,true,false);
				}
			}
		}

		private void mnuUnMigrateListItems_Click(object sender, System.EventArgs e)
		{
			int count = lvComponents.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = lvComponents.SelectedItems.GetEnumerator();
				IRMComponent irm;
				irm = (IRMComponent)m_lastSelectedNode.Tag;
				long sourceId = irm.FlPlnCmpntID;
				int viewId = irm.FlPlnViewID;
				string msg = "Remove the Selected Items from the Container: " + irm.FlPlnCmpntNm;
				if(MessageBox.Show(this,msg,"Component Operations",MessageBoxButtons.YesNo) == DialogResult.No)
				{
					return;
				}
				items.Reset();
				while(items.MoveNext())
				{
					ListViewItem lvi = (ListViewItem)items.Current;
					irm = (IRMComponent)lvi.Tag;
					try
					{
						m_session.getFilePlanComponentController().removeFromSource(irm.FlPlnCmpntID,sourceId,viewId);
						lvi.Remove();
					}
					catch(System.Net.WebException we)
					{
						util.logWebException(we);
						return;
					}
					catch(System.Web.Services.Protocols.SoapException s)
					{
						util.handleSoapException(s,false); //false indicates we will not check for time out here
						util.showSoapException(s);
						return;
					}
				}
				CommonTasks.Refresh(m_session,m_lastSelectedNode,viewId,sourceId,true,true);
			}
		}

		private void mnuViewListItem_Click(object sender, System.EventArgs e)
		{
			int count = lvComponents.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = lvComponents.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				IRMComponent irm = (IRMComponent)lvi.Tag;
				CommonTasks.viewSeletedItem(this,m_session,irm);
			}
		}

		private void mnuDeleteListItem_Click(object sender, System.EventArgs e)
		{
			CommonTasks.DeleteListItems(this,m_session,util,lvComponents);
		}

		private void cntxtMnuListView_Popup(object sender, System.EventArgs e)
		{
			mnuAddListItemTarget.Enabled = true;
			mnuEditListItem.Enabled = true;
			mnuViewListItem.Enabled = true;
			mnuDeleteListItem.Enabled = true;
			mnuSearchListItem.Enabled = true;
			mnuMigrateLitsItems.Enabled = true;
			mnuUnMigrateListItems.Enabled = true;

			int count = lvComponents.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = lvComponents.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				IRMComponent irm = (IRMComponent)lvi.Tag; 
				if(irm.FlPlnCmpntID != 0)
				{

				}
				else
				{
					mnuEditListItem.Enabled = false;
					mnuViewListItem.Enabled = false;
					mnuDeleteListItem.Enabled = false;
					mnuMigrateLitsItems.Enabled = false;
					mnuUnMigrateListItems.Enabled = false;
				}
			}
		}
		#endregion

		#region UtilityMethods
		//Adds nCount components for all allowed targets for nFlPlnCmpntID
		private void addFilePlanComponents(long nFlPlnCmpntID, long nFlPlnViewID, long nCount)
		{
			string xml = m_session.getFilePlanComponentController().getAllowedTargetList(nFlPlnCmpntID,nFlPlnViewID);
			XmlDocument doc = new XmlDocument();
			try
			{
				doc.LoadXml(xml);
				XmlNodeList itemNodes = doc.GetElementsByTagName("Item");
				for(int i = 0; i < itemNodes.Count; i++)
				{
					string strFlPlnCmpntDefNm = itemNodes.Item(i).Attributes.GetNamedItem("FlPlnCmpntDefNm").Value;
					string strFlPlnCmpntDefTgtID = itemNodes.Item(i).Attributes.GetNamedItem("FlPlnCmpntDefTgtID").Value;
					
					string compDefList = "<List><Item FlPlnCmpntDefID='" + strFlPlnCmpntDefTgtID + "'></Item></List>";
					string test = m_session.getNavigationController().getTargetList(nFlPlnViewID,nFlPlnCmpntID,0,compDefList,0,0);
					XmlDocument doc2 = new XmlDocument();
					try
					{
						doc2.LoadXml(test);
						XmlNodeList itemNodes2 = doc2.GetElementsByTagName("Item");
						int begin = itemNodes2.Count + 1; 
						
						long nFlPlnCmpntDefTgtID = System.Convert.ToInt64(strFlPlnCmpntDefTgtID);

						for(int j = begin; j < begin + nCount; j++)
						{
							string name = strFlPlnCmpntDefNm + (j);
							xml =	"<Fields>" +
								"<Field FlPlnCmpntAttrDefColNm='FlPlnCmpntNm'>" + name + "</Field>" +
								"<Field FlPlnCmpntAttrDefColNm='FlPlnCmpntTtl'>" + name + "</Field>" +
								"</Fields>";
						
							try
							{
								m_session.getFilePlanComponentController().addFilePlanComponent(nFlPlnCmpntDefTgtID,xml,nFlPlnCmpntID);
							}
							catch(System.Web.Services.Protocols.SoapException s)
							{
								util.handleSoapException(s,false);
							}
						}
					}
					catch(XmlException e3)
					{
						util.logXMLErr(e3, "getTargetList(" + nFlPlnViewID + ", " + nFlPlnCmpntID + ",0, " + compDefList + ",0,0)");
					}
				}
			}
			catch(XmlException e4)
			{
				util.logXMLErr(e4, "getAllowedTargetList(" + nFlPlnCmpntID + ", " + nFlPlnViewID + ")");
			}

		}
		#endregion

		#region FormAndMenuEvents
		private void Form1_Load(object sender, System.EventArgs e)
		{
			doLogin(this.m_isHostLogin);
		}

		private void mnuLogin_Click(object sender, System.EventArgs e)
		{
			doLogin(false);
		}

		private void mnuHostLogin_Click(object sender, System.EventArgs e)
		{
			doLogin(true);
		}

		private void doLogin(bool isHostLogin)
		{
			try
			{
				if(initClientSession(isHostLogin))
				{
					//Clear Treeview
					tvFilePlan.Nodes.Clear();
					CommonTasks.DrawFilePlan(m_session,tvFilePlan);
				}
			}
			catch(System.Net.WebException we)
			{
				m_bLoggedIn = false;
				util.logWebException(we);
			}
			catch(System.Web.Services.Protocols.SoapException s)
			{
				m_bLoggedIn = false;
				util.handleSoapException(s,false);
			}
		}

		//public static int EXPAND_LISTS = 1; 
		//public static int EXPAND_LISTS_AND_PROFILE_FIELDS = 3; 
		//public static int EXPAND_LISTS_AND_PROFILE_FIELDS_NO_FLS = 4; 
		//public static int NONE = 0; 
		//public static int PROFILE_FIELDS = 2; 

		private void mnuTestCode_Click(object sender, System.EventArgs e)
		{
			if(MessageBox.Show(this,"TEST CODE HERE. This Mehtod will ERASE all logged messages! Do you wish to continue?","WARNING",MessageBoxButtons.YesNo,MessageBoxIcon.Warning) == DialogResult.No)
			{
				return;
			}

			//textBox1.Text = m_session.getUserController().getUserById(-1,true);
			//textBox1.Text = m_session.getTemplateController().getNewComponent(21,0,0,EXPAND_LISTS_AND_PROFILE_FIELDS);

			//string xml = m_session.getTemplateController().getNewComponent(21,0,0,EXPAND_LISTS_AND_PROFILE_FIELDS);
			//XmlDocument doc = new XmlDocument();
			//doc.LoadXml(xml);

			//string xpath = "/Field[@FlPlnCmpntAttrDefColNm='TS_Location']"; 

			//textBox1.Text = doc.SelectSingleNode(xpath).Value;

			//string newTitle = "Look Ma I changed my title at " + System.DateTime.Now;
			//m_session.getFilePlanComponentController().setFilePlanComponentField(148,"FlPlnCmpntTtl", newTitle);

			//textBox1.Text = m_session.getQueryController().getQueryById(22);

			//int nContainerDefId = 21;
			
			//string query = 
			//"<Fields>" +
			//	"<Field FlPlnCmpntAttrDefColNm=\"FlPlnCmpntDefID\">" + nContainerDefId + "</Field>" +
			//	"<Field FlPlnCmpntAttrDefColNm=\"QueryImage\">" +
			//		"<![CDATA[<ReportTemplate><Version>4.1.1</Version><ReportLayout/><Scope/><BlockSize>0</BlockSize><BlockStart>0</BlockStart><Distinct>0</Distinct><Query><Condition/><SortFields/><OutputFields><OutputField>TS_FlPlnCmpnt.FlPlnCmpntNm</OutputField></OutputFields></Query><GetEligibleFilePlanComponents><ReferenceDateFrom/><ReferenceDateTo/><IncludeDisposalAuthority>0</IncludeDisposalAuthority><EligibleForCutoff>0</EligibleForCutoff><EligibleForClose>0</EligibleForClose><EligibleForTransition>1</EligibleForTransition><LifeCycleQueryType>1</LifeCycleQueryType><PhaseId/></GetEligibleFilePlanComponents></ReportTemplate>]]>" +
			//	"</Field>" +
			//"</Fields>";

			/*
			 * JMS message can only be seen by user who originated the report or a member of the Administrators group.
			 * We could save the taskId returned from the beginTask method or found in the XML result from the
			 * getStatusListByTaskId method that the originator of the report calls.
			 * This task Id could be used to retrieve the results of the life cycle query allowing other users to view the results.
			*/

			//string taskId = "414d51205741535f54505457454947415dc1b54120000601";
			//textBox1.Text = m_session.getBatchController().getStatusListByTaskId(taskId);

			//com.ibm.gre.engine.types.LogTypes 
			//int ERROR_LOG = 2; 
			//int META_DATA_LOG = 4; 
			//int RESULT_LOG = 3; 
			//int TRANSITION_LOG = 1; 

			//textBox1.Text = m_session.getBatchController().getTaskResultsByID(taskId,RESULT_LOG,0,0);

			//textBox1.Text = m_session.getQueryController().getReportColumnsList(21);

			///////////////////// IRMQuery tests ///////////////////
			
			//string xmlQuery = m_session.getQueryController().getQueryById(81);
			//IRMQuery irmQuery = new IRMQuery(xmlQuery,m_session, "",true, OptionalFields.NO_FIELDS);
			//textBox1.Text = irmQuery.QueryImage;
			//textBox1.Text = irmQuery.ComponentName;
			//textBox1.Text = irmQuery.Query;
			//textBox1.Text = irmQuery.Test;

			//irmQuery.setFieldValue("TS_FlPlnCmpnt_Cst21.TS_TransitNumber_1","345");

			//textBox1.Text = irmQuery.getFieldValue("TS_FlPlnCmpnt_Cst21.TS_TransitNumber_1");
			
			//textBox1.Text = irmQuery.Condition;

			//xmlQuery = irmQuery.ModifiedQuery;
			//textBox1.Text = m_session.getQueryController().runQuery(xmlQuery,2);
			
			//textBox1.Clear();
			//for(int i = 0; i < irmQuery.LineCount; i++)
			//{
			//	Line line = irmQuery.getLine(i);
			//	string test = line.Caption + "  DatTyp: " + line.FlPlnCmpntAttrDefDatTyp + " PickListId: " + line.PickListId + " FieldOperator" + line.LineType;

			//	log(test + "\r\n");
			//}
			
			//textBox1.Text = "this.m_serverNamePort: " + this.m_serverNamePort + "\r\nthis.m_databaseJNDIName: " + this.m_databaseJNDIName;

		}

		private void tabControl2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(tabControl2.SelectedTab.Name == "tabLifeCycleReports")
			{
				if(m_bLoggedIn)
				{
					DrawLifeCycleReports();
				}
			}
		}

		#endregion

		#region LifeCycleReportListEvents
		private void mnuViewLifeCycleResults_Click(object sender, System.EventArgs e)
		{
			int count = lvLifeCycleReports.SelectedItems.Count;
			if(count > 0)
			{
				string taskId = null;
				IEnumerator items = lvLifeCycleReports.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				taskId = (string)lvi.Tag;

				string xmlResultList = m_session.getBatchController().getTaskResultsByID(taskId,(int)IRMConstants.LogTypes.RESULT_LOG,0,0);
				IRMLifeCycleResultList rl = new IRMLifeCycleResultList(xmlResultList);

				//Make sure that only the following columns will be displayed
				rl.AddColumn("NameFullPath");
				rl.AddColumn("Conflict");
				rl.AddColumn("NextEligiblePhaseName");
				rl.AddColumn("NextEligiblePhaseDate");

				LifeCycleResultListForm lcrlFrm = new LifeCycleResultListForm(taskId, m_session,this,rl,0,true);
				lcrlFrm.Show();

			}
		}

		private void mnuDeleteLifeCycleResults_Click(object sender, System.EventArgs e)
		{
			int count = lvLifeCycleReports.SelectedItems.Count;
			if(count > 0)
			{
				string msg = "Delete Selected Tasks and all related tasks?";
				IEnumerator items = lvLifeCycleReports.SelectedItems.GetEnumerator();
				if(count > 1)
				{
					if(MessageBox.Show(this,msg,"Life Cycle Operations",MessageBoxButtons.YesNo) == DialogResult.No)
					{
						return;
					}
				}
				while(items.MoveNext())
				{
					ListViewItem lvLifeCycleReportsi = (ListViewItem)items.Current;
					if(count == 1)
					{
						msg = "Delete Task: " + lvLifeCycleReportsi.Text + " and all related tasks";
						if(MessageBox.Show(this,msg,"Life Cycle Operations",MessageBoxButtons.YesNo) == DialogResult.No)
						{
							return;
						}
					}
					try
					{
						
						string taskName = lvLifeCycleReportsi.Text;

						string xml = m_session.getBatchController().getTaskList(m_session.getUserController().getUserId());
						IRMList list = new IRMList(xml,"TaskID","TaskName");

						//Remove all items that are TRANSITION_FILE_PLAN_COMPONENTS or GET_ELIGIBLE_FILE_PLAN_COMPONENTS tasks
						//and have the same name as the current task (cheap trick)
						for(int i = list.Count - 1; i > -1; i--)
						{
							int taskType = Convert.ToInt32(list.getAttributeValue(i,"Type"));
							if(taskType == (int)IRMConstants.AsynchronousTaskType.TRANSITION_FILE_PLAN_COMPONENTS
								|| taskType == (int)IRMConstants.AsynchronousTaskType.GET_ELIGIBLE_FILE_PLAN_COMPONENTS)
							{
								if(taskName == list.Caption(i))
								{
									m_session.getBatchController().deleteFinishedTask(list.PrimaryKey(i));
								}
							}
						}
					}
					catch(System.Net.WebException we)
					{
						util.logWebException(we);
						return;
					}
					catch(System.Web.Services.Protocols.SoapException s)
					{
						util.handleSoapException(s,false); //false indicates we will not check for time ou here
						util.showSoapException(s);
						return;
					}
					lvLifeCycleReportsi.Remove();
				}
			}			
		}

		private void mnuTransitionLifeCycleResults_Click(object sender, System.EventArgs e)
		{
			int count = lvLifeCycleReports.SelectedItems.Count;
			if(count > 0)
			{
				string strTransferContentDir = CommonTasks.getEngineConfigValue(m_session,util,"sysTransferRecordsContentDir");
				if(strTransferContentDir == "")
				{
					MessageBox.Show("Transferred Records Content Directory value has not been set. Set this value in the System Configuration of the IBM DB2 Records Manager Administrator.");
					return;	
				}

				string strKeepDisposedMetaDataFlag = CommonTasks.getEngineConfigValue(m_session,util,"sysKeepMetaDataOnAccession");				
				if(strKeepDisposedMetaDataFlag == "")
				{
					strKeepDisposedMetaDataFlag = "0";
				}
				
				string strTransferMetaDataDir = CommonTasks.getEngineConfigValue(m_session,util,"sysTransferRecordsMetaDataDir");				
				if(strTransferMetaDataDir == "")
				{
					MessageBox.Show("Transferred Records Meta Data Directory value has not been set. Set this value in the System Configuration of the IBM DB2 Records Manager Administrator.");
					return;	
				}

				string msg = "Transition ALL Selected Life Cycle Result Lists?";
				IEnumerator items = lvLifeCycleReports.SelectedItems.GetEnumerator();
				if(count > 1)
				{
					if(MessageBox.Show(this,msg ,"Life Cycle Operations",MessageBoxButtons.YesNo) == DialogResult.No)
					{
						return;
					}
				}
				string taskId;
				while(items.MoveNext())
				{
					ListViewItem lvLifeCycleReportsi = (ListViewItem)items.Current;
					taskId = (string)lvLifeCycleReportsi.Tag;
					if(count == 1)
					{
						msg = "Transition the Life Cycle Result List: " + lvLifeCycleReportsi.Text;
						if(MessageBox.Show(this,msg,"Life Cycle Operations",MessageBoxButtons.YesNo) == DialogResult.No)
						{
							return;
						}
					}
					try
					{
						//TODO this is a real cheap way to co-ordinate tasks
						//Just use the same unique name for all
						string taskName = lvLifeCycleReportsi.Text;
						string xml =
						"<Fields>" +
                            "<Field FlPlnCmpntAttrDefColNm=\"SourceTaskID\">" + taskId + "</Field>" + 
							"<Field FlPlnCmpntAttrDefColNm=\"TransferContentDir\">" + strTransferContentDir + "</Field>" +
							"<Field FlPlnCmpntAttrDefColNm=\"KeepDisposedMetaDataFlag\">" + strKeepDisposedMetaDataFlag + "</Field>" +
							"<Field FlPlnCmpntAttrDefColNm=\"TransferMetaDataDir\">" + strTransferMetaDataDir + "</Field>" + 
						"</Fields>";
						
						m_session.getBatchController().beginTask((int)IRMConstants.AsynchronousTaskType.TRANSITION_FILE_PLAN_COMPONENTS,xml,taskName,"");
					}
					catch(System.Net.WebException we)
					{
						util.logWebException(we);
						return;
					}
					catch(System.Web.Services.Protocols.SoapException s)
					{
						util.handleSoapException(s,false); //false indicates we will not check for time out here
						util.showSoapException(s);
						return;
					}
				}
			}			
		}

		private void menuViewTransitionResults_Click(object sender, System.EventArgs e)
		{
			int count = lvLifeCycleReports.SelectedItems.Count;
			if(count > 0)
			{
				IEnumerator items = lvLifeCycleReports.SelectedItems.GetEnumerator();
				items.MoveNext();
				ListViewItem lvi = (ListViewItem)items.Current;
				
				string taskName = lvi.Text;

				string xml = m_session.getBatchController().getTaskList(m_session.getUserController().getUserId());
				IRMList list = new IRMList(xml,"TaskID","TaskName");

				//Remove all items that are not TRANSITION_FILE_PLAN_COMPONENTS tasks
				//and do not have the same name as the current task (cheap trick)
				for(int i = list.Count - 1; i > -1; i--)
				{
					int taskType = Convert.ToInt32(list.getAttributeValue(i,"Type"));
					if(taskType != (int)IRMConstants.AsynchronousTaskType.TRANSITION_FILE_PLAN_COMPONENTS)
					{
						list.removeItem(i);
					}
					else
					{
						if(taskName != list.Caption(i))
						{
							list.removeItem(i);
						}
					}
				}
				if(list.Count == 0)
				{
					MessageBox.Show("No Transition results for this item");
				}
				else
				{
					TransitionResultsForm frm = new TransitionResultsForm(m_session,this,list);
					frm.Show();
				}
			}
		}

		#endregion
		
		#region LifeCycleReportListMethods

		private void DrawLifeCycleReports()
		{
			lvLifeCycleReports.Items.Clear();
			lvLifeCycleReports.Columns.Clear();
			long nUserId = m_session.getUserController().getUserId();
			string xml = m_session.getBatchController().getTaskList(nUserId);
			IRMList list = new IRMList(xml,"TaskID","TaskName");

			float totalWidth = lvLifeCycleReports.Width;
			
			int width = (int)(.4 * totalWidth);
			lvLifeCycleReports.Columns.Add("Task Name",width,HorizontalAlignment.Left);
			width = (int)(.1 * totalWidth);
			lvLifeCycleReports.Columns.Add("Status",width,HorizontalAlignment.Left);
			width = (int)(.2 * totalWidth);
			lvLifeCycleReports.Columns.Add("Start Time",width,HorizontalAlignment.Left);
			width = (int)(.1 * totalWidth);
			lvLifeCycleReports.Columns.Add("% Done",width,HorizontalAlignment.Left);
			width = (int)(.2 * totalWidth);
			lvLifeCycleReports.Columns.Add("Status Time",width,HorizontalAlignment.Left);

			for(int i = 0; i < list.Count; i++)
			{
				ListViewItem item = new ListViewItem(list.Caption(i));
				
				int type = Convert.ToInt32(list.getAttributeValue(i,"Type"));

				//Only Add GET_ELIGIBLE_FILE_PLAN_COMPONENTS task type
				if(type == (int)IRMConstants.AsynchronousTaskType.GET_ELIGIBLE_FILE_PLAN_COMPONENTS)
				{
					string strStatus = list.getAttributeValue(i,"Status");
					int nStatus = Convert.ToInt32(strStatus);
					item.SubItems.Add(Util.makeStatusMsg(nStatus));
					item.SubItems.Add(list.getAttributeValue(i,"StartTime"));
					item.SubItems.Add(strStatus);
					item.SubItems.Add(list.getAttributeValue(i,"StatusTime"));

					item.Tag = list.PrimaryKey(i);
					lvLifeCycleReports.Items.Add(item);
				}
			}

		}
		#endregion

	}
}
