using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// Summary description for IRMTaskResultsForm.
	/// </summary>
	public class IRMTaskResultsForm : System.Windows.Forms.Form
	{
		private bool valid = true;

		private IRMBatchQuery m_irmBatchQuery;
		private IRMLifeCycleResultList m_irmLifeCycleResultList;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button btnRefresh;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Button btnOkay;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public IRMTaskResultsForm(IRMBatchQuery irmBatchQuery)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_irmBatchQuery = irmBatchQuery;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.btnOkay = new System.Windows.Forms.Button();
			this.btnRefresh = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnOkay);
			this.panel1.Controls.Add(this.btnRefresh);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(560, 309);
			this.panel1.TabIndex = 0;
			// 
			// btnOkay
			// 
			this.btnOkay.Location = new System.Drawing.Point(472, 264);
			this.btnOkay.Name = "btnOkay";
			this.btnOkay.TabIndex = 3;
			this.btnOkay.Text = "Okay";
			this.btnOkay.Click += new System.EventHandler(this.btnOkay_Click);
			// 
			// btnRefresh
			// 
			this.btnRefresh.Location = new System.Drawing.Point(384, 264);
			this.btnRefresh.Name = "btnRefresh";
			this.btnRefresh.TabIndex = 0;
			this.btnRefresh.Text = "Refresh";
			this.btnRefresh.Click += new System.EventHandler(this.btnRefresh_Click);
			// 
			// textBox1
			// 
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.textBox1.Location = new System.Drawing.Point(0, 0);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(560, 248);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "textBox1";
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 248);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(560, 3);
			this.splitter1.TabIndex = 2;
			this.splitter1.TabStop = false;
			// 
			// IRMTaskResultsForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 309);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.panel1);
			this.Name = "IRMTaskResultsForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "IRMTaskResultsForm";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.IRMTaskResultsForm_Closing);
			this.Load += new System.EventHandler(this.IRMTaskResultsForm_Load);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnRefresh_Click(object sender, System.EventArgs e)
		{
			reLoad();
		}

		private void IRMTaskResultsForm_Load(object sender, System.EventArgs e)
		{
			reLoad();
		}

		private void reLoad()
		{
			int status = m_irmBatchQuery.runQuery(0,0); 
			if(status > 0)
			{
				textBox1.Text = "The task " + m_irmBatchQuery.TaskName + " is " + status + "% done";
				if(status == 100)
				{
					btnRefresh.Enabled = false;
				}
			}
			else
			{
				textBox1.Text = "The task " + m_irmBatchQuery.TaskName + " Status is " + Util.makeStatusMsg(status);
			}
		}

		private void btnOkay_Click(object sender, System.EventArgs e)
		{
			int status = m_irmBatchQuery.runQuery(0,0); 
			if(status > 0)
			{
				if(status == 100)
				{
					m_irmLifeCycleResultList = new IRMLifeCycleResultList(m_irmBatchQuery);
					DialogResult = DialogResult.OK;
					this.Close();
				}
				else
				{
					MessageBox.Show("The task " + m_irmBatchQuery.TaskName + " is " + status + "% done");
					DialogResult = DialogResult.Abort;
					valid = false;
				}
			}
			else
			{
				MessageBox.Show("The task " + m_irmBatchQuery.TaskName + " Status is " + Util.makeStatusMsg(status));
				DialogResult = DialogResult.Abort;
				valid = false;
			}
		}

		private void IRMTaskResultsForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(!valid)
			{
				e.Cancel = true;
				valid = true;
			}
		}

		public IRMLifeCycleResultList LifeCycleResultList
		{
			get
			{
				return m_irmLifeCycleResultList;
			}
		}

		public string TaskID
		{
			get
			{
				return m_irmBatchQuery.TaskId;
			}
		}

	}
}
