using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// Summary description for ListForm.
	/// </summary>
	public class ListForm : System.Windows.Forms.Form
	{
		private ArrayList m_columns;
		private string m_xmlList;

		private System.Windows.Forms.ListView listView1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ListForm(string xmlList)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_xmlList = xmlList;

			m_columns = new ArrayList();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listView1 = new System.Windows.Forms.ListView();
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView1.FullRowSelect = true;
			this.listView1.Location = new System.Drawing.Point(0, 0);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(512, 269);
			this.listView1.TabIndex = 0;
			this.listView1.View = System.Windows.Forms.View.Details;
			// 
			// ListForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 269);
			this.Controls.Add(this.listView1);
			this.Name = "ListForm";
			this.Text = "ListForm";
			this.Load += new System.EventHandler(this.ListForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		public void addColumnInfo(string colName, string label)
		{
			ColumnInfo info = new ColumnInfo(colName, label);
			m_columns.Add(info);
		}

		private void ListForm_Load(object sender, System.EventArgs e)
		{
			//listView1.Columns.Add
			float totalWidth = listView1.Width;
			int count = m_columns.Count;
			int width = (int)(totalWidth/(float)count);

			for(int i = 0; i < count; i++)
			{
				listView1.Columns.Add(((ColumnInfo)m_columns[i]).Caption,width,HorizontalAlignment.Left);
			}

			XmlDocument doc = new XmlDocument();
			doc.LoadXml(m_xmlList);
			XmlElement root = doc.DocumentElement;
			XmlNodeList items = root.ChildNodes;
			for(int i = 0; i < items.Count; i++)
			{
				XmlElement item = (XmlElement)items.Item(i);
				
				ListViewItem lvItem = null;

				for(int j = 0; j < count; j++)
				{
					string colName = ((ColumnInfo)m_columns[j]).ColumnName;
					string val = item.Attributes.GetNamedItem(colName).Value;
					//Add special code for the Conflict field
					if(colName == "Conflict")
					{
						val = CommonTasks.makeConflictName(val);
					}
					if(j == 0)
					{
						lvItem = new ListViewItem(val);
					}
					else
					{				
						lvItem.SubItems.Add(val);
					}
				}
				listView1.Items.Add(lvItem);

			}

		}
	}

	public class ColumnInfo
	{
		private string m_columnName;
		private string m_caption;

		public ColumnInfo(string columnName, string caption)
		{
			m_columnName = columnName;
			m_caption = caption;
		}

		public string ColumnName
		{
			get 
			{
				return m_columnName;
			}
		}

		public string Caption
		{
			get 
			{
				return m_caption;
			}
		}
	}
}
